#pragma once         // Include guard should be present in *all* header files. It may not be necessary now, 
                     // but you never know when it will becomes necessary later when this file becomes included 
                     // by more than one file as the code base evolves. 
class Player;        // The code below uses Player*, which does not require to know the size of Player objects, 
                     //   so only a class forward reference is required.
#include <string>    // The Country class declares a member of type string. 
using std::string;
#include <iostream>  // operator<< uses ostream
using std::ostream; 

class Country {
public:
	Player* owner;
	static int numRegisteredCountries;
	Country();
	Country(Player* owner);
	string getName();
private:
	string name;
};

// It may be declared as a friend, but does not need to, as its implementation does not use private members. 
// If it is not declared as friend, it needs to be declared as a free operator here.
// Uses ostream, Country&
ostream& operator<<(ostream& os, Country& co); 