// All required files/libraries should be explicitly listed. 
// It leads to confusion to rely on included files to include the required inclusions of another file. 

#include "Player.h"    // Below is the implementation of the members of the Player class, which are listed in the class declaration in the Player.h file
#include "Country.h"   // The below Player operator<< uses the Country operator<<, so it needs its declaration, which is in the Country.h file. 
#include<iostream>     // The code below uses cout, which is in the iostream library. 
using std::ostream; 
using std::cout; 
using std::endl; 
#include <string>      // The code below uses to_string and string. 
using std::to_string; 
using std::string; 
// Note that the code below does not use vector, even though its class declaration does. 
// It is confusing and wasteful to include libraries that are not required for the compilation of a unit. 

// uses ostream, Player&, Country*, cout, and Country's friend operator<<
ostream& operator<<(ostream& os, Player& pl) {
	os << pl.getName() << " : owned countries are : " << endl;
	for (Country* c : pl.ownedCountries)
		os << *c;
	cout << endl;
	return os;
}

// uses Player, string
Player::Player() {
	numRegisteredPlayers++;
	name = "player" + to_string(numRegisteredPlayers);
};

// uses Player
string Player::getName() {
	return name;
}

// uses Player
int Player::numRegisteredPlayers = 0;
