#include <iostream>
#include <vector>
#include <string>
using namespace std;

class Player;

class Country {
public:
    Player* owner;
    static int numRegisteredCountries;
    Country() : owner(NULL), name("") {
        numRegisteredCountries++;
    }
    Country(Player* owner) : owner(owner) {
        numRegisteredCountries++;
        name = "country" + to_string(numRegisteredCountries);
    }
    string getName() {
        return name;
    }
private:
    string name;
    friend ostream& operator<<(ostream& os, Country& co);
};

class Player {
public:
    vector<Country*> ownedCountries;
    static int numRegisteredPlayers;
    Player() {
        numRegisteredPlayers++;
        name = "player" + to_string(numRegisteredPlayers);
    };
    string getName() {
        return name;
    };
private:
    string name;
    friend ostream& operator<<(ostream& os, Player& pl);
};

const int numPlayers = 4;
const int numCountries = 13;
int Player::numRegisteredPlayers = 0;
int Country::numRegisteredCountries = 0;

ostream& operator<<(ostream& os, Country& co) {
    os << co.name << " : owner is " << co.owner->getName() << endl;
    return os;
}

ostream& operator<<(ostream& os, Player& pl) {
    os << pl.name << " : owned countries are : " << endl;
    for (Country* c : pl.ownedCountries)
        os << *c;
    cout << endl;
    return os;
}

int main() {
    vector<Player*> allPlayers;
    vector<Country*> allCountries;
    for (int i = 1; i <= numPlayers; i++)
        allPlayers.push_back(new Player());
    for (int j = 0; j <= numCountries - 1; j++) {
        allPlayers.at(j % numPlayers)->ownedCountries.push_back(new Country(allPlayers.at(j % numPlayers)));
    }
    for (int k = 0; k <= numPlayers - 1; k++)
        cout << *allPlayers.at(k);
}